<?php
namespace CAWmedia\Cawlogin\UserFunc;

/**
 * This class generates the flexform data for EXT:gridelementes
 */
class GridelementsFlexForms implements \TYPO3\CMS\Core\SingletonInterface {

    protected $columnConfiguration = array(
        '2col' => array(
            12 => array(12, 12),
            1 => array(6, 6),
            2 => array(3, 9),
            3 => array(9, 3),
            4 => array(4, 8),
            5 => array(8, 4),
        ),
        '3col' => array(
            12 => array(12, 12, 12),
            1 => array(4, 4, 4),
            2 => array(3, 6, 3),
            3 => array(6, 3, 3),
            4 => array(3, 3, 6),
            4 => array(3, 6, 3),
            4 => array(2, 8, 2),
        ),
		'4col' => array(
            12 => array(12, 12, 12, 12),
            1 => array(6, 6, 6, 6),
            2 => array(3, 3, 3, 3),
        )
    );

    protected $columns = array(
        1 => 1,
        2 => 2,
        3 => 3,
        4 => 4,
        5 => 5,
        6 => 6,
        7 => 7,
        8 => 8,
        9 => 9,
        10 => 10,
        11 => 11,
        12 => 12,
    );

    protected $optionColumns = array(
        0 => 0,
        1 => 1,
        2 => 2,
        3 => 3,
        4 => 4,
        5 => 5,
        6 => 6,
        7 => 7,
        8 => 8,
        9 => 9,
        10 => 10,
        11 => 11,
    );

    protected $orderColumns = array(
        1 => 1,
        2 => 2,
        3 => 3,
        4 => 4,
        5 => 5,
        6 => 6,
    );



    public function getOrderColumn($conf) {
        $options = $this->orderColumns;
        $column = array();

        foreach ($this->orderColumns as $value) {
            $column[] = array(
                $value,
                $value,
            );
        }

        $conf['items'] = array_merge($conf['items'], $column);

        return $conf;
    }

    public function getOrderConfiguration () {
        return $this->orderColumns;
    }

    public function getOptionColumn($conf) {
        $options = $this->optionColumns;
        $column = array();

        foreach ($this->optionColumns as $value) {
            $column[] = array(
                $value,
                $value,
            );
        }

        $conf['items'] = array_merge($conf['items'], $column);

        return $conf;
    }


    public function getOffsetConfiguration () {
        return $this->optionColumns;
    }

    public function getColumnConfiguration ($colClass = NULL) {
        $conf = $this->columnConfiguration;
        if (isset($conf[$colClass])) {
            $conf = $conf[$colClass];
        }
        return $conf;
    }

    protected function getColConf ($colClass, $conf) {
        $column = array();
        foreach ($this->columnConfiguration[$colClass] as $value => $columnConf) {
            $column[] = array(
                implode(' | ', $columnConf),
                $value,
            );
        }

        $conf['items'] = array_merge($conf['items'], $column);


        return $conf;
    }

    public function get2ColConf($conf) {
        return $this->getColConf('2col', $conf);
    }

    public function get3ColConf($conf) {
        return $this->getColConf('3col', $conf);
    }

    public function get4ColConf($conf) {
        return $this->getColConf('4col', $conf);
    }

    public function getGeneralColumnConf($conf) {
        $options = $this->columns;
        $column = array();

        foreach ($this->columns as $value) {
            $column[] = array(
                $value,
                $value,
            );
        }

        $conf['items'] = array_merge($conf['items'], $column);

        return $conf;
    }

    public function getColumn($colClass = NULL) {
        $conf = $this->columns;
        if (isset($conf[$colClass])) {
            $conf = $conf[$colClass];
        }
        return $conf;
    }

}