<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2008 Jan Roemich <jroemich@dpi-one.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * LOGIN // LOGOUT
 *
 *
 *
 *   71: class tx_cawlogin_pi1 extends tx_cawlogin_pi
 *
 *              SECTION: Main function
 *  113:     function init()
 *  139:     function main($content, $conf)
 *
 * TOTAL FUNCTIONS: 1
 *
 */






















require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('cawlogin').'plugins/pi/class.tx_cawlogin_pi.php');

/**
 * Plugin 'Customerlogin [Login | Logout]' for the 'caw_login' extension.
 *
 * @author	Jan Roemich <jroemich@dpi-one.de>
 * @package	TYPO3
 * @subpackage	tx_cawlogin
 */
class tx_cawlogin_pi1 extends tx_cawlogin_pi {
    public $prefixId = 'tx_cawlogin_pi1';		// Same as class name
    public $scriptRelPath = 'plugins/pi1/class.tx_cawlogin_pi1.php';	// Path to this script relative to the extension dir.
    public $extKey = 'cawlogin';	// The extension key.




    /**
     * The main method of the PlugIn
     *
     * @param	string		$strContent: The PlugIn content
     * @param	array		$arrConf: The PlugIn configuration
     * @return	The content that is displayed on the website
     */
    public function main($strContent, array $arrConf)	{
        $this->conf = $arrConf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        $this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
        $this->pi_initPIflexForm();

        // Main initialization
        parent::init();

        // Which mode is selected
        switch ($this->piVars['mode']) {
            case 'login':
                if ($this->checkLogin($this->piVars['ordernr'], $this->piVars['password'])) {
                    $strContent = $this->login($this->piVars['ordernr'], $this->piVars['password']);
                    $overrulePIvars = array(
                        'mode' => 'redirect',
                        'url' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'redirectOnLogin'.($this->session['isAdmin'] ? 'Admin' : '')),
                    );
                    $this->pi_redirect($overrulePIvars['url']);
//                    $this->pi_redirect($this->pi_linkTP_keepPIvars_url($overrulePIvars, false, true));
                } else {
                    $this->invalid = TRUE;
                    $strContent = $this->showLogin();
                }
                break;

            case 'redirect':
                $strUrl = $this->piVars['url'];
                $this->pi_redirect($strUrl);
                break;

            default:
                if ($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'isLogout')) {
                    $this->logout();
                    $this->pi_redirect($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'redirectOnLogout'));
                }
                $strContent = $this->showLogin();
                break;
        }
        // Substitute language, formular and data marker
        $strContent = $this->pi_TPLsubstituteFormularMarker($strContent);
        $strContent = $this->pi_TPLsubstituteDataMarker($strContent, $this->piVars);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);

        return $this->pi_wrapInBaseClass($strContent);
    }

    /**
     * The showLogin method of the PlugIn
     *
     * @return	string		The content that is displayed on the website
     */
    protected function showLogin() {
        $strFileResource = $this->cObj->stdWrap($this->conf['templateFile'], $this->conf['templateFile.']);
        $strTemplate = $this->cObj->fileResource($strFileResource);
        return (string) $this->cObj->getSubpart($strTemplate, '###'.$this->prefixId.'###');
    }
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi1/class.tx_cawlogin_pi1.php'])	{
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi1/class.tx_cawlogin_pi1.php']);
}
