<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2008 Jan Roemich <jroemich@dpi-one.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/


/**
 * KUNDENCENTER
 *
 *
 *
 *   71: class tx_cawlogin_pi4 extends tx_cawlogin_pi
 *
 *              SECTION: Main function
 *  113:     function init()
 *  139:     function main($content, $conf)
 *
 * TOTAL FUNCTIONS: 1
 *
 */























require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('cawlogin').'plugins/pi/class.tx_cawlogin_pi.php');


/**
 * Plugin 'CAW Customer center' for the 'cawlogin' extension.
 *
 * @author	Jan Roemich <jroemich@dpi-one.de>
 * @package	TYPO3
 * @subpackage	tx_cawlogin
 */
class tx_cawlogin_pi4 extends tx_cawlogin_pi {
    public $prefixId      = 'tx_cawlogin_pi4';		// Same as class name
    public $scriptRelPath = 'plugins/pi4/class.tx_cawlogin_pi4.php';	// Path to this script relative to the extension dir.
    public $extKey        = 'cawlogin';	// The extension key.
    public $data = array(
        'is_customer1_checked' => '',
        'is_customer0_checked' => '',
        'lastorderno' => '',
        'lastorderno_disabled' => '',
        'lastorderno_unknown_checked' => '',
        'company' => '',
        'industry' => '',
        'name' => '',
        'firstname' => '',
        'position' => '',
        'address' => '',
        'zip' => '',
        'city' => '',
        'telephone' => '',
        'fax' => '',
        'email' => '',
    );
    public $insertData = array(
        'company' => 'partner_firma',
        'industry' => 'partner_branche',
        'name' => 'partner_nachname',
        'firstname' => 'partner_vorname',
        'position' => 'partner_position',
        'address' => 'partner_adresse',
        'zip' => 'partner_plz',
        'city' => 'partner_ort',
        'telephone' => 'partner_tel',
        'fax' => 'partner_fax',
        'email' => 'partner_email',
    );
    public $requiredData = 'is_customer:EREG:/^[01]$/,company,name,firstname,address,zip:EREG:/^[0-9]{4}$|^[0-9]{5}$/,city,telephone,email:EMAIL';




    /**
     * The main method of the PlugIn
     *
     * @param	string		$strContent: The PlugIn content
     * @param	array		$arrConf: The PlugIn configuration
     * @return	The content that is displayed on the website
     */
    public function main($strContent, array $arrConf)	{
        $this->conf = $arrConf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        $this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!

        // Main initialization
        parent::init();

        // Save customer data
        if ($this->referer() && $this->piVars['save']) {
            $this->saveCustomerData();
            if (!$this->invalid) {
                $this->pi_redirect(\TYPO3\CMS\Core\Utility\GeneralUtility::_GP('redirect') ? \TYPO3\CMS\Core\Utility\GeneralUtility::_GP('redirect') : $GLOBALS['TSFE']->id);
            }
        }
        // Display formular only
        $strContent = $this->showCustomerFormular();

        // Substitute language, formular and data marker
        $strContent = $this->pi_TPLsubstituteFormularMarker($strContent);
        $strContent = $this->pi_TPLsubstituteDataMarker($strContent, $this->data);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);
        $this->pi_TPLpublicateJavascript();
        return (string)$this->pi_wrapInBaseClass($strContent);
    }

    /**
     * Save the submitted customer data, if valid
     *
     * @return	void
     */
    private function saveCustomerData() {
        // Check the data for validation
        if ($this->pi_DATAvalidate($this->piVars)) {
            // Go through each data to insert and create the array
            $arrFields = array();
            foreach ($this->insertData as $strSource => $strKey) {
                if (!\TYPO3\CMS\Core\Utility\GeneralUtility::inList($this->invalid, $strSource) && $strKey) {
                    $arrFields[$strKey] = utf8_decode($this->piVars[$strSource]);
                }
            }
            // Insert last customer number
            if ($this->piVars['is_customer']) {
                $arrFields['partner_alterauftrag'] = ($this->piVars['lastorderno_unknown'] || !$this->piVars['lastorderno']) ? -1 : $this->piVars['lastorderno'];
                $strNoQuoteFields = '';
            } else {
                $arrFields['partner_alterauftrag'] = 'NULL';
                $strNoQuoteFields = 'partner_alterauftrag';
            }
            // Insert new values into database
            if (!$this->pi_DBgetPartner()) {
                $arrFields['partner_auftrag'] = $this->session['ordernr'];
                $this->db->exec_INSERTquery("Login_partner", $arrFields, $strNoQuoteFields);
            } else {
                $this->db->exec_UPDATEquery("Login_partner", "partner_auftrag='".$this->session['ordernr']."'", $arrFields, $strNoQuoteFields);
            }
        }
    }

    /**
     * Show the formular content of the customer center.
     *
     * @return	string		The content of the page
     */
    private function showCustomerFormular() {
        // Get the values from database
        $arrPartner = $this->pi_DBgetPartner();
        // Insert the values with the right syntax
        foreach ($this->data as $strKey => $mixValue) {
            // Get the row name from database and set it to the data array
            if ($this->insertData[$strKey]) {
                $this->data[$strKey] = $arrPartner[$this->insertData[$strKey]];
            }
            // Nothing is written to database, so use the current piVars value
            if ($this->invalid) {
                $this->data[$strKey] = $this->piVars[$strKey];
                // This item is not filled in correctly, so display the invalid value
                if (\TYPO3\CMS\Core\Utility\GeneralUtility::inList($this->invalid, $strKey)) {
                    $arrConf = is_array($this->conf['locallang.'][$strKey.'.']) ? $this->conf['locallang.'][$strKey.'.'] : array();
                    $this->conf['locallang.'][$strKey.'.'] = \TYPO3\CMS\Core\Utility\ArrayUtility::mergeRecursiveWithOverrule($arrConf, $this->conf['locallang.']['errorField.']);
                }
            }
        }
        // Set the is_customer and lastorderno values
        if ((!is_null($arrPartner['partner_alterauftrag']) || !$arrPartner) && (!$this->invalid || $this->piVars['is_customer'])) {
            $this->data['is_customer1_checked'] = ' checked="checked"';
            if ($arrPartner['partner_alterauftrag'] == -1 || ($this->invalid && $this->piVars['lastorderno_unknown'])) {
                $this->data['lastorderno_unknown_checked'] = ' checked="checked"';
            } else {
                $this->data['lastorderno'] = ($this->invalid) ? $this->data['lastorderno'] : $arrPartner['partner_alterauftrag'];
            }
        } else {
            $this->data['is_customer0_checked'] = ' checked="checked"';
            $this->data['lastorderno_disabled'] = ' disabled="disabled"';
        }

        // Get the template
        $strFileResource = $this->cObj->stdWrap($this->conf['templateFile'], $this->conf['templateFile.']);
        $strTemplate = $this->cObj->fileResource($strFileResource);
        return (string)$this->cObj->getSubpart($strTemplate, '###'.$this->prefixId.'###').$debug;
    }

    /**
     * Publicate the javascript code into the output content. Creates an temporary file if extension is not USER_INT, otherwise
     *
     * @return	void
     * @see		tx_cawlogin_pi:pi_TPLpublicateJavascript
     */
    public function pi_TPLpublicateJavascript() {
        // Get the javascript template
        $strFileResource = $this->cObj->stdWrap($this->conf['javascriptFile'], $this->conf['javascriptFile.']);
        $strContent = $this->cObj->fileResource($strFileResource);
        $strContent = $this->cObj->getSubpart($strContent, '###'.$this->prefixId.'###');
        // Create array for substitution into javascript
        $this->data['ajaxUrl'] = $this->pi_linkTP_keepPIvars_url(array('mode' => 'ajax', 'ort' => $this->piVars['ort']), 0, 1);
        // Substitute marker
        $strContent = $this->pi_TPLsubstituteDataMarker($strContent, $this->data);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);
        parent::pi_TPLpublicateJavascript($strContent);
    }
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi4/class.tx_cawlogin_pi4.php'])	{
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi4/class.tx_cawlogin_pi4.php']);
}
