<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2008 Jan Roemich <jroemich@dpi-one.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/


/**
 * PLAKATMOTIV BEARBEITEN
 *
 *
 *
 *   71: class tx_cawlogin_pi5 extends tx_cawlogin_pi
 *
 *              SECTION: Main function
 *  113:     function init()
 *  139:     function main($content, $conf)
 *
 * TOTAL FUNCTIONS: 1
 *
 */























require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('cawlogin').'plugins/pi/class.tx_cawlogin_pi.php');
require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('cawlogin').'plugins/libs/TurboWeb2Print.php');



/**
 * Plugin 'CAW Edit postermotif' for the 'cawlogin' extension.
 *
 * @author	Jan Roemich <jroemich@dpi-one.de>
 * @package	TYPO3
 * @subpackage	tx_cawlogin
 */
class tx_cawlogin_pi5 extends tx_cawlogin_pi {
    public $prefixId       = 'tx_cawlogin_pi5';		// Same as class name
    public $scriptRelPath  = 'plugins/pi5/class.tx_cawlogin_pi5.php';	// Path to this script relative to the extension dir.
    public $extKey         = 'cawlogin';	// The extension key.
    public $data = array(
        'helpboxes' => '',
    );
    public $designer = '';
    public $tbObj = null;



    /**
     * The main method of the PlugIn
     *
     * @param	string		$strContent: The PlugIn content
     * @param	array		$arrConf: The PlugIn configuration
     * @return	string		The content that is displayed on the website
     */
    public function main($strContent, array $arrConf)	{
        $this->conf = $arrConf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
        $this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
        $this->pi_initPIflexForm();

        $this->cObj->data['header_layout'] = '100';

        // Main initialization
        parent::init();
        $strFileResource = $this->cObj->stdWrap($this->conf['templateFile'], $this->conf['templateFile.']);
        $strTemplate = $this->cObj->fileResource($strFileResource);
        $strTemplate = $this->cObj->getSubpart($strTemplate, '###'.$this->prefixId.'###');

        $orderData = $this->pi_DBgetOrder();
        $this->uploadFolder = $this->conf['imagePath'];

        $GLOBALS['TSFE']->register['login_motiv'] = 0;
        // Get the template
        if (empty($orderData['auftrag_motivordner']))
        {
            /*
                // Partner informations are not available
                $arrData = $this->pi_DBgetPartner();
                $strContent = $this->cObj->getSubpart($strTemplate, !$arrData ? 'ERROR' : 'INTERFACE');
                // Fetch the data from database
                if (is_array($arrData)) {
                    $arrData = \TYPO3\CMS\Core\Utility\GeneralUtility::array_merge_recursive_overrule($arrData, (array)$this->pi_DBgetOrder());
                    $this->data = arrData;
                }
                */
            $strContent = $this->cObj->getSubpart($strTemplate, 'ERROR');
            $this->pi_redirect((int)$this->conf['locallang.']['next.']['typolink.']['parameter']);

        } else {
            $this->designer = $orderData['auftrag_motivordner'];
            $files = array();
            foreach (explode(',', $this->cObj->data['image']) as $file) {
                if (strpos($file, $this->designer.'_') === 0) {
                    $files[] = $file;
                }

            }

            $this->tbObj = new TurboWeb2Print($this->designer, $this->conf['designerPath'], $this->session);
            $this->dir = $this->tbObj->getDirectoryList();
            if (!$this->dir) die("Es trat ein Fehler auf!");
            sort ($this->dir);
            // Save the selection
            $this->firstCall = false;
            // autogen für sammelaufträge
            if (!empty($this->piVars['create_all_id'])) {
                if (empty($GLOBALS['BE_USER']->user)) {
                    die('Bitte im Backend erst anmelden!');
                }
                die('programm ende');
            }
            if (isset($this->piVars['select'])) {

                $ret = $this->rendermotiv($this->dir[$this->piVars['select']]);
                $this->firstCall = TRUE;
                // wenn keine Eindruckdaten vorhanden sind dann, gehe zur feritg seite
                if ($ret['motiv_accepted']) {
                    $page = $this->cObj->data['pages'];
                    if ($page) $this->redirect($this->pi_getPageLink($page));
                }
            }

            if (isset($this->piVars['reset'])) {
                if ($preview) {
                    if (file_exists(PATH_site.$this->conf['imagePath'].$preview)) {
                        unlink(PATH_site.$this->conf['imagePath'].$preview);
                    }
                }
                $data = array(
                    'poster' => '',
                    'preview' => '',
                    'poster_selected' =>'',
                );

                $this->db->exec_UPDATEquery('Login_auftrag_motive', "auftrag_nummer='".$this->session['ordernr']."'", $data);                
                // Create new hash name
                $hash = $this->designer.'_'.substr($this->session['ordernr'], -31 + strlen($designer));
                // Delete finished designer images
                \TYPO3\CMS\Core\Utility\GeneralUtility::getURL(\TYPO3\CMS\Core\Utility\GeneralUtility::locationHeaderUrl($this->conf['designerPath'].'server/services/deleteFinished.php?code='.$hash));
                // Redirect to defined Page
                $page = isset($this->conf['resetPage.']) ? $this->cObj->stdWrap($this->conf['resetPage'], $this->conf['resetPage.']) : $this->conf['resetPage'];
                if ($page) $this->redirect($this->pi_getPageLink($page));
            }



            // Get the current selected poster

            $res = $this->db->exec_SELECTquery('poster_selected,preview,motiv_accepted', 'Login_auftrag_motive', "auftrag_nummer='".$this->session['ordernr']."' AND poster_selected!=''");
            $row = $this->db->sql_fetch_row($res);
            list($poster_selected, $preview, $motiv_accepted) = $row;
            // The user has already selected an poster
            if ($poster_selected) {
            	
                $this->template = $this->cObj->getSubpart($strTemplate, 'MOTIFBUILDER');

                $pI = pathinfo($poster_selected);
                // Define designer object



                $this->tbObj->getDocument($pI['filename']);
                $this->fields = $this->tbObj->get('tag', 'field', 'code');
                $this->uploadFields = $this->tbObj->get('tag', 'dummybox', 'name');


                // Get input fields
                $this->setData();

                // Error while getting input fields
                if (count($this->errorFields) && !$this->firstCall && !empty($this->piVars)) {
#				$this->subparts['ERROR'] = trim($this->cObj->getSubpart($this->template, '###ERROR###'));
                    $errorFields = trim(sprintf($this->p123_getLL('error_field'), implode(', ', $this->errorFields)));
                    $errorText = trim($this->p123_getLL('error'));
                    $this->p123_setLL('error', trim($errorFields.chr(10).$errorText));
                }

                $auftrag = $this->pi_DBgetOrder();
                if (!$auftrag['motiv_accepted']) {
                    $this->rendermotiv($poster_selected);
                }
                // Render preview
                if ($this->piVars['preview']) {
                    $this->firstCall = TRUE;
                    $this->rendermotiv($poster_selected);
                    // Render image and save it to designer framework
                } elseif ($this->piVars['complete']) {
                        // var_dump($poster_selected);
                        // var_dump(($this->errorFields));
                        // die('#');
                    if (($this->piVars['datachecked'] || $this->piVars['ineedhelp']) && !count($this->errorFields)) {
                        $this->piVars['datachecked'] = 1;
                        $this->session['includeMail']['ineedhelp'] = $this->piVars['ineedhelp'] ? 1 : 0;
                        $this->pi_SESsave();

                        $this->rendermotiv($poster_selected, '', TRUE);
                        $page = isset($this->conf['readyPage.']) ? $this->cObj->stdWrap($this->conf['readyPage'], $this->conf['readyPage.']) : $this->conf['readyPage'];
                        if (!$page) $page = $this->cObj->data['pages'];
                        if ($page) $this->redirect($this->pi_getPageLink($page));
                    } else {
                        $errorText = trim($this->p123_getLL('error'));
                        $errorCheck = trim($this->p123_getLL('error_datacheck'));
                        $this->p123_setLL('error', trim($errorText.chr(10).$errorCheck));
                        $this->subparts['ERROR'] = trim($this->cObj->getSubpart($this->template, '###ERROR###'));
                    }
                }




                // Store preview into temp dir, in order to get the dimensions
                $docData = $this->tbObj->get('tag', 'document');
                // Recalculate width and height
                $proportion = 1;

                if (\TYPO3\CMS\Core\Utility\MathUtility::canBeInterpretedAsInteger($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerwidth'))) {
                    $proportion = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerwidth') / $docData[0]['attributes']['width'];
                    $docData[0]['attributes']['height'] = round($docData[0]['attributes']['height'] / $docData[0]['attributes']['width'] * $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerwidth'));
                    $docData[0]['attributes']['width'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerwidth');
                    // Height is greater than designerheight from flexform
                    if (\TYPO3\CMS\Core\Utility\MathUtility::canBeInterpretedAsInteger($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerheight')) && $docData[0]['attributes']['height'] > $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerheight')) {
                        $proportion = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerheight') / $docData[0]['attributes']['height'];
                        $docData[0]['attributes']['width'] = round($docData[0]['attributes']['width'] / $docData[0]['attributes']['height'] * $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerheight'));
                        $docData[0]['attributes']['height'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerheight');
                    }
                } elseif (\TYPO3\CMS\Core\Utility\MathUtility::canBeInterpretedAsInteger($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerheight'))) {
                    $proportion = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerheight') / $docData[0]['attributes']['height'];
                    $docData[0]['attributes']['width'] = round($docData[0]['attributes']['width'] / $docData[0]['attributes']['height'] * $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerheight'));
                    $docData[0]['attributes']['height'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerheight');
                }



                if ($docData[0]['attributes']['width'] && !$motiv_accepted) {
                    $preview = preg_replace('/width\=[0-9]+[\&]?/i', '', $preview);
                    $preview .= (preg_match('/\?/', $preview) ? '&' : '?').'width='.round($docData[0]['attributes']['width']);
                }
                if ($docData[0]['attributes']['height'] && !$motiv_accepted) {
                    $preview = preg_replace('/height\=[0-9]+[\&]?/i', '', $preview);
                    $preview .= (preg_match('/\?/', $preview) ? '&' : '?').'height='.round($docData[0]['attributes']['height']);
                }


                $tmpName = 'typo3temp/pics/'.\TYPO3\CMS\Core\Utility\GeneralUtility::shortMD5($this->prefixId.'|'.$preview).'.png';
                \TYPO3\CMS\Core\Utility\GeneralUtility::writeFileToTypo3tempDir(PATH_site.$tmpName, \TYPO3\CMS\Core\Utility\GeneralUtility::getURL(\TYPO3\CMS\Core\Utility\GeneralUtility::locationHeaderUrl($preview.'&cacheBuster='.time().'.png')));
                // Render the image
                $this->data['image'] = $this->cObj->IMAGE(array_merge(array('file' => $tmpName), $this->conf['preview.']));
                $this->data['image'] = '<a title="Zoom" target="_blank "href="'.$preview.'&width=1200&height=1200KeepThis=true&TB_iframe=true" class="xthickbox">'.str_replace('src="'.$tmpName.'"', 'src="'.$preview.'&cacheBuster='.time().'"', $this->data['image']).'</a>';
                \TYPO3\CMS\Core\Utility\GeneralUtility::unlink_tempfile(PATH_site.$tmpName);

                $preview .= '&_='.time();
                // Make preview link width and height
                $linkWidth = round($docData[0]['attributes']['width']) * 2;
                $linkHeight = $linkWidth / round($docData[0]['attributes']['width']) * round($docData[0]['attributes']['height']);
                // Parse preview title
                $linkTitle = trim(preg_replace('/\{[^\}]*\}/s', '', $docData[0]['attributes']['name']));
                $linkTitle = trim(preg_replace('/[:\.,;]+$/s', '', $linkTitle));
                // Make preview link file

                //$linkFile = \TYPO3\CMS\Core\Utility\GeneralUtility::camelCaseToLowerCaseUnderscored(\TYPO3\CMS\Core\Utility\GeneralUtility::underscoredToLowerCamelCase($linkTitle));
                $linkFile = $linkTitle;
                // Make preview link
                $linkPreview = str_replace(
                    array('getPreview.php?', 'width='.round($docData[0]['attributes']['width']), 'height='.round($docData[0]['attributes']['height'])),
                    array('getPreview.php/'.$linkFile.'.png?', 'width='.round($linkWidth), 'height='.round($linkHeight)),
                    $preview
                );
                // Set the image wrapped with the link
                $this->data['image'] = '<img src="'.$preview.'" border="0" alt="preview" />';
                $this->data['image'] = $this->cObj->wrap($this->data['image'], '<a href="'.$linkPreview.'" target="_blank" class="thickbox" title="'.htmlspecialchars($linkTitle).'">|</a>');
                // Wrap the loader container
                $this->data['image'] = $this->cObj->wrap($this->data['image'], '<div class="preview" style="height:'.$docData[0]['attributes']['height'].'px; width:'.$docData[0]['attributes']['width'].'px;">|</div>');



                // Motif already build
                if ($motiv_accepted) {
                    $this->subparts['ERROR'] = '';
                    list($preview) = \TYPO3\CMS\Core\Utility\GeneralUtility::trimExplode('&', $preview);
                    $this->data['image'] = $this->cObj->IMAGE(array_merge(array('file' => $this->conf['imagePath'].$preview), (array)$this->conf['preview.']));
                    //$this->subparts['FORMULAR2'] = trim($this->cObj->getSubpart($this->template, '###FORMULAR2###'));
                    $this->data['helpboxes'] = '';
                } else {
                    $this->template = $this->cObj->substituteSubpart($this->template, '###FORMULAR2###', '');
                    $this->subparts['FORMULAR'] = trim($this->cObj->substituteSubpart(trim($this->cObj->getSubpart($this->template, '###FORMULAR###')), '###FIELDS###', $this->createDynamicForm()));
                    if (empty($this->piVars['reloadAjax'])) {
                        $boxes = array();
                        // Create helpboxes if there is no ajax
                        foreach ($this->fields as $key) {
                            $cur = array();
                            $found = FALSE;
                            if(count($tbObj->xmlVals))
                                foreach ($tbObj->xmlVals as $data) {
                                    if (isset($data['attributes'])) $cur = $data['attributes'];
                                    if (preg_match('/\{'.$key['attributes']['code'].'\}/isU', $data['value'])) {
                                        $found = TRUE;
                                        break;
                                    } elseif (strtolower($data['tag']) == 'dummybox' && $key['attributes']['code'] == $data['attributes']['name']) {
                                        $cur = $data['attributes'];
                                        $cur['isImage'] = TRUE;
                                        $found = TRUE;
                                        break;
                                    }
                                }
                            if ($found) {
                                // Set the value of the box
                                if (!isset($boxes[$cur['x'].'-'.$cur['y'].'-'.$cur['width'].'-'.$cur['height']]['value']))
                                    $boxes[$cur['x'].'-'.$cur['y'].'-'.$cur['width'].'-'.$cur['height']]['value'] = $data['value'] ? $data['value'] : '{'.$key['attributes']['code'].'}';
                                // Replace the markers
                                $boxes[$cur['x'].'-'.$cur['y'].'-'.$cur['width'].'-'.$cur['height']]['value'] = preg_replace(
                                    '/\{'.$key['attributes']['code'].'\}/isU',
                                    ($this->p123_getLL('field'.$key['attributes']['code']) ? '###LL_field'.$key['attributes']['code'].'###' : $key['attributes']['code']),
                                    $boxes[$cur['x'].'-'.$cur['y'].'-'.$cur['width'].'-'.$cur['height']]['value']
                                );
                                $boxes[$cur['x'].'-'.$cur['y'].'-'.$cur['width'].'-'.$cur['height']]['value'] = trim(str_replace(array(CRLF, LF, CR), array('<br />'), $boxes[$cur['x'].'-'.$cur['y'].'-'.$cur['width'].'-'.$cur['height']]['value']));
                                $lines = (substr_count($boxes[$cur['x'].'-'.$cur['y'].'-'.$cur['width'].'-'.$cur['height']]['value'], '<br />') + 1);
                                if (strpos($boxes[$cur['x'].'-'.$cur['y'].'-'.$cur['width'].'-'.$cur['height']]['value'], '###LL_field'.$key['attributes']['code'].'###') !== FALSE) {
                                    $lines += substr_count($this->p123_getLL('field'.$key['attributes']['code']), '<br');
                                }
                                // Define the CSS of the box
                                $css = array(
                                    'font-family' => $cur['font'] ? $cur['font'].',sans-serif' : '',
                                    'font-size' => $cur['fontSize'] ? round($cur['fontSize'] / 10 * 1.3, 1).'em' : '',
                                    'font-style' => $cur['italic'] ? 'italic' : '',
                                    'font-weight' => ($cur['bold'] || stripos($cur['font'], 'bold') !== FALSE) ? 'bold' : '',
                                    'height' => round($cur['height'] * $proportion * 1.3).'px',
                                    'line-height' => $cur['isImage'] ? round(($cur['height'] * $proportion * 1.3) / $lines).'px' : ($cur['fontSize'] ? round(($cur['fontSize'] / 10 * 1.3) / $lines, 1).'em' : ''),
                                    'margin-top' => round($cur['y'] * $proportion).'px',
                                    'margin-left' => round($cur['x'] * $proportion).'px',
                                    'text-align' => \TYPO3\CMS\Core\Utility\GeneralUtility::inList('left,center,right', strtolower($cur['align'])) ? strtolower($cur['align']) : '',
                                    'width'	=> round($cur['width'] * $proportion).'px',
                                );
                                $boxes[$cur['x'].'-'.$cur['y'].'-'.$cur['width'].'-'.$cur['height']]['style'] = $this->implodeCSS($css, ': ', '; ');
                                $boxes[$cur['x'].'-'.$cur['y'].'-'.$cur['width'].'-'.$cur['height']]['rel'] .= ' '.$key['attributes']['code'];
                            }
                        }
                        foreach ($boxes as $box) {
                            $this->data['helpboxes'] .= '<div class="helpbox" rel="'.trim($box['rel']).'" style="'.trim($box['style']).'">'.$box['value'].'</div>';
                        }

                    }
                }
                $strContent = $this->cObj->substituteSubpart($this->template, '###FORMULAR###', $this->subparts['FORMULAR'] );
            } else {
                if (count($this->dir) == 1) {
                    $page = $this->pi_getPageLink($GLOBALS['TSFE']->id,'',array($this->prefixId.'[select]'=> 0));
                    if ($page) $this->redirect($this->pi_getPageLink($page));
                    exit();
                }
                $strContent = $this->erzeuge_motivauswahl();
            }
        }
        // Substitute language, formular and data marker
        $strContent = $this->pi_TPLsubstituteFormularMarker($strContent);
        //doemedia: Add form action - begin
        $arrMarks = array('action' => $this->pi_getPageLink($this->conf['motifpage']));
        $strContent = $this->cObj->substituteMarkerArray($strContent, $arrMarks, '###FORM_|###');
        //doemedia: Add form action - end
        $strContent = $this->pi_TPLsubstituteDataMarker($strContent, (array)$this->data);
        $strContent = $this->pi_TPLsubstituteLanguageMarker($strContent);

        $code = '';



        return (string)$this->pi_wrapInBaseClass($strContent).$code;



    }

    protected function erzeuge_motivauswahl() {
        $desc = array();
        foreach ($this->dir as $key => $name) {
            $Ownhash = $designer.'_'.$key;
            if (in_array($Ownhash.'.png', $files)) continue;

            $hash = $this->designer.'_'.$key.'_gen';
            $image_hash =$hash.'.png';
            $image_scr = PATH_site.$this->conf['imagePath'].$image_hash;

            if ($this->tbObj->getDocument($name)) {
                if (!empty($this->tbObj->xmlVals[0][attributes][desc])) $desc[] = $this->tbObj->xmlVals[0][attributes][desc];

                if ((!file_exists($image_scr) && !in_array($image_hash, $files)) || filemtime($image_scr) < (time() - 86400)) {
                    $this->tbObj->setContents();
                    if ($this->tbObj->saveOrderDocument($hash)) {
                        $preview = $this->conf['designerPath'].'server/services/getPreview.php?width=400&height=200&code='.$hash;
                        $content = \TYPO3\CMS\Core\Utility\GeneralUtility::getURL(\TYPO3\CMS\Core\Utility\GeneralUtility::locationHeaderUrl($preview));
                        \TYPO3\CMS\Core\Utility\GeneralUtility::writeFile($image_scr, $content);

                    }

                }
                $files[] = $image_hash;
            }

        }
        asort($files,  SORT_STRING);
        $this->cObj->data['image'] = implode(',', $files);
        $this->cObj->data['imagecaption'] = implode (chr(10), $desc);
        return trim($this->cObj->cObjGetSingle($this->conf['1'], (array)$this->conf['1.']));
    }


    protected function setData() {
        // Image upload
        $error = '';
        foreach ($this->uploadFields as $uname => $ufields) {
            // Reset this image
            if (isset($this->piVars[$uname.'_reset'])) {
                @unlink(PATH_site.$this->conf['imagePath'].basename($this->piVars[$uname]));
                $this->piVars[$uname] = '';
                $this->piVars['preview'] = 1;
                continue;
            }
            if ($_FILES) {       
                // Check for uploaded file
                $maxFileSize = (!empty($ufields['attributes']['maxfilesize']) ? $ufields['attributes']['maxfilesize'] : 5) * 1024 * 1024;
                $allowedTypes = !empty($ufields['attributes']['type']) ? $ufields['attributes']['type'] : str_replace(',', '|', $GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext']);
                $minW = !empty($ufields['attributes']['minwidth']) ? $ufields['attributes']['minwidth'] : 0;
                $minH = !empty($ufields['attributes']['minheight']) ? $ufields['attributes']['minheight'] : 0;
                // Found an uploaded image and filesize is greater than zero
                if (isset($_FILES[$uname.'_temp']) && $_FILES[$uname.'_temp']['size'] > 0 && $_FILES[$uname.'_temp']['error'] == 0) {
                    $fileInfo = pathinfo($_FILES[$uname.'_temp']['name']);
                    
                    // var_dump($_FILES[$uname.'_temp']);
                    // var_dump($fileInfo);
                    
                    // Filetype is not allowed
                    // This can't work in past! Type is always like "image/jpeg" and we need extension of uploaded file
                    // if (!preg_match('/'.$allowedTypes.'/i', $_FILES[$uname.'_temp']['type'])) {
                    if (!preg_match('/'.$allowedTypes.'/i', strtoupper($fileInfo['extension']))) {
                        $error .= chr(10).$uname.': '. sprintf($this->p123_getLL('error_file'), str_replace('|', ',', $allowedTypes));
                        @unlink($_FILES[$uname.'_temp']['tmp_name']);
                        continue;
                    }
                    // Filesize is lower than defined maxFileSize
                    if ($_FILES[$uname.'_temp']['size'] > $maxFileSize) {
                        $error .= chr(10).$uname.': '.$this->p123_getLL('error_filesize');
                        @unlink($_FILES[$uname.'_temp']['tmp_name']);
                        continue;
                    }
                    // File is an image, so we can check, pdf and so one can not be checked
                    if (preg_match('/image/i', $_FILES[$uname.'_temp']['type'])) {
                        // Load constants for imageMagick
                        \TYPO3\CMS\Core\Utility\GeneralUtility::requireOnce($this->conf['designerPath'].'server/libraries/constants.inc.php');
                        $im = (defined('IMAGEMAGICK_PATH')) ? IMAGEMAGICK_PATH.'/' : $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path'];
                        // Get width and height from uploaded image
                        exec($im.'identify -format "%w %h" '.escapeshellcmd($_FILES[$uname.'_temp']['tmp_name']), $imReturn);
                        list($w, $h)  = explode(' ', $imReturn[0]);
                        // when an min hight or whitg is given than try to find out if its right
                        if ($minW>0 || $minH>0) {
                            // Width and height of uploaded image is lower than required one
                            if ($w < $minW || $h < $minH) {
                                $error .= chr(10).$uname.': '.$this->p123_getLL('error_size');
                                @unlink($_FILES[$uname.'_temp']['tmp_name']);
                                continue;
                            }
                        } else {
                            // if the program should do it automatic, dont use any minHeigth or minWidth
                            $tbObj = new TurboWeb2Print('', $this->conf['designerPath'], $this->session);
                            list($minW, $minH) = ($tbObj->getNewBoxSize($w, $h, $ufields['attributes']['width'], $ufields['attributes']['height']));
                            unset($tbObj);
                            if ($w < $minW && $h < $minH) {
                                $min = ($minW <$minH) ? $minW : $minH;
                                $error .= chr(10).$uname.': '. sprintf($this->p123_getLL('error_size'), $min, $min);
                                @unlink($_FILES[$uname.'_temp']['tmp_name']);
                                continue;
                            }
                        }
                    }
                    // Create filename an store the image to the destination directory                    
                    $fileName = \TYPO3\CMS\Core\Utility\GeneralUtility::shortMD5($this->prefixId.'|'.$_FILES[$uname.'_temp']['name'].$_FILES[$uname.'_temp']['size']).'.'.$fileInfo['extension'];
                    \TYPO3\CMS\Core\Utility\GeneralUtility::upload_copy_move($_FILES[$uname.'_temp']['tmp_name'], PATH_site.$this->conf['imagePath'].$fileName);
                    if (file_exists(PATH_site.$this->conf['imagePath'].$fileName)) {
                        $this->piVars[$uname] = $fileName;
                    }
                }
            } elseif (!isset($this->piVars[$uname.'_reset']) && !isset($this->piVars[$uname]) && $this->fields[$uname]['value']) {
                if (PATH_site.$this->conf['imagePath'].$this->fields[$uname]['value'] != \TYPO3\CMS\Core\Utility\GeneralUtility::resolveBackPath(PATH_site.$this->conf['imagePath'].$this->fields[$uname]['value'])) {
                    $filePath = \TYPO3\CMS\Core\Utility\GeneralUtility::resolveBackPath(PATH_site.$this->conf['imagePath'].$this->fields[$uname]['value']);
                    $fileInfo = pathinfo($filePath);
                    $fileName = \TYPO3\CMS\Core\Utility\GeneralUtility::shortMD5($this->prefixId.'|'.$this->fields[$uname]['value'].'|'.filesize($filePath)).'.'.strtolower($fileInfo['extension']);
                    if (\TYPO3\CMS\Core\Utility\GeneralUtility::upload_copy_move($filePath, PATH_site.$this->conf['imagePath'].$fileName) || file_exists(PATH_site.$this->conf['imagePath'].$fileName)) {
                        $this->piVars[$uname] = $fileName;
                        $this->piVars['preview'] = 1;
                    }
                }
            }
        }
        unset($_FILES);
        // Errors occured
        if ($error) $this->p123_setLL('error', nl2br(trim($error)));
        $feuser = $this->pi_DBgetPartner();
        // Check required fields
        foreach ($this->fields as $field) {
            $fname = $field['attributes']['code'];
            // Get value by piVars
            if (isset($this->piVars[$fname])) {
                $this->data[$fname] = trim(strip_tags($this->piVars[$fname]));
                // Get value by fe_user
            } elseif ($field['value']) {
                $parts = explode ('|',trim($field['value']));
                if (count($parts) == 2) {
                    if (isset($feuser[$parts[0]])) {
                        $this->data[$fname] = empty($feuser[$parts[0]]) ? $parts[1] : $feuser[$parts[0]];
                    } else {
                        $this->data[$fname] = $parts[1];
                    }
                } else {
                    $this->data[$fname] = trim($field['value']);
                }
            }

            // This field is required, but not filled in
            if (!empty($field['attributes']['required'])) {
                $value = trim($this->data[$fname]);
                if (!$value || strlen($value) < $field['attributes']['required']) {
                    $this->errorFields[$fname] = $this->pi_getLL('field'.$fname) ? '###LL_field'.$fname.'###' : $fname;
                }
            }
            // Crop the field
            if (!empty($field['attributes']['size'])) {
                $value = trim($this->data[$fname]);
                if (strlen($value) > (int)$field['attributes']['size']) {
                    $this->data[$fname] = substr($value, 0, (int)$field['attributes']['size']);
                }
            }
            // Upper or lower case the field value
            if (!empty($field['attributes']['case']) && !empty($this->data[$fname])) {
                $case = 'to'.ucwords($GLOBALS['TSFE']->csConvObj->conv_case('utf-8', $field['attributes']['case'], 'toLower'));
                if (\TYPO3\CMS\Core\Utility\GeneralUtility::inList('toUpper,toLower', $case)) {
                    $this->data[$fname] = $GLOBALS['TSFE']->csConvObj->conv_case('utf-8', $this->data[$fname], $case);
                }
            }
            // htmlSpecialChars for values
            if (!empty($this->data[$fname])) {
                $this->data[$fname] = htmlSpecialChars($this->data[$fname]);
            }
        }
    }

    /**
     * Erzeuge die Motiv-Vorschau bzw. das Endmotiv
     *
     * @param	string		$filepath: The filename of the image to render
     * @param	string		$desc: Description of the motif
     * @param	boolean		$finished: Whether to create complete PDF (true), or only preview (false)
     * @return	void
     */
    protected function rendermotiv($filepath, $desc='', $finished=FALSE, $autogen=false) {
        //\TYPO3\CMS\Core\Utility\GeneralUtility::loadTCA('tt_content');
        // Create new hash name
        $this->hash =  $this->session['ordernr'];
        $hash = $this->designer.'_'.substr($this->hash, -31 + strlen($this->designer));
        // Get the filename of the motif, eg "test.jpg"
        $pI = pathinfo($this->uploadFolder.'/'.$filepath);
        // Get the motif "test" from designer
        $motif = $this->tbObj->getDocument($pI['filename']);
        // Define the array to store in database
        $data = array(
            'motiv_accepted' => $finished ? 1 : 0,
            'poster' => '',
            'preview' => '',
            'poster_selected' => $filepath,
            'auftrag_nummer' => $this->hash
        );


        //if ($this->query['posterSelection'] != $pI['filename']) {
        //	$this->query['posterSelection'] = $pI['filename'];
        //	$this->saveQuery();
        //}

        // Store image description if set
        if (trim($desc)) {
            $data['poster_description'] = trim($desc);
        }
        // There is a motif stored in the designer
        if ($motif) {
            // Get the predefined fields from designer XML and set the data
            $this->fields = $this->tbObj->get('tag', 'field');
            $this->uploadFields = $this->tbObj->get('tag', 'dummybox', 'name');
            if (empty($this->fields) && empty($this->uploadFields)) {
                $finished = TRUE;
                $data['motiv_accepted'] = 1;
            }
            $this->setData();
            // Fill in the predefined fields for the designer with the data and files
            $dataFields = $this->data;
            $filelist = array();
            foreach($this->data as $k => $v) {
                if (isset($this->uploadFields[$k]) && !empty($v)) {
                    $filelist[] = PATH_site.$this->conf['imagePath'].$v;
                    $dataFields[$k] = PATH_site.$this->conf['imagePath'].$v;
                } else {
                    $dataFields[$k] = htmlspecialchars_decode($v);
                }
            }
            // Store the fields and used files to the designer
            $dataFields['sid'] = $this->sid;
            //$res = $this->db->exec_SELECTquery('*', 'Login_partner', 'partner_auftrag='.(int)$this->hash);
            // User already exists, set the user to disabled and to the usergroup
            //if ($this->db->sql_num_rows($res)) {
            //	print_r($this->db->sql_fetch_assoc($res));
            //}
            $this->tbObj->setContents($dataFields);
            $this->tbObj->saveOrderDocument($hash, $filelist);
            // Store the preview image to database
            $w = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerwidth') !== null ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerwidth') : 600;
            $h = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerheight') !== null ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'designerheight') : 300;
            $data['preview'] = $this->conf['designerPath'].'server/services/getPreview.php?width='.$w.'&height='.$h.'&code='.$hash;
            // The motif is accepted or no motif is found in the designer, so store the image as ready
            if ($finished) {
                // Store the preview image, not as Link only
                $data['poster'] = $this->conf['designerPath'].'server/services/getPdf.php?code='.$hash;
                if ( $autogen==false ) {
                    // Load the content of the file
                    $content = \TYPO3\CMS\Core\Utility\GeneralUtility::getURL(\TYPO3\CMS\Core\Utility\GeneralUtility::locationHeaderUrl($data['preview']));
                    if ($content) {
                        // Copy the file to the ready directory
                        $image_hash = $this->hash.time().'.jpg';
                        if (\TYPO3\CMS\Core\Utility\GeneralUtility::writeFile(PATH_site.$this->conf['imagePath'].$image_hash, $content)) {
                            $info = $this->cObj->getImgResource('uploads/tx_p123designer/'.$image_hash, $this->conf['preview.']['file.']);
                            if ($info) {
                                unlink($info['origFile']);
                                rename($info[3], $info['origFile']);
                            }
                            $data['preview'] = $image_hash;
                        }
                    }
                }
            }
            // There is no motif stored in the designer, store the selection to the database only
        } else {
            $data['motiv_accepted'] = '1';
            $data['poster'] = $this->uploadFolder.'/'.$filepath;
            $data['preview'] = $hash.'.'.$pI['extension'];
            // Copy preview image to the ready directory
            \TYPO3\CMS\Core\Utility\GeneralUtility::upload_copy_move(PATH_site.$data['poster'], PATH_site.$this->conf['imagePath'].$data['preview']);
        }
        // var_dump($data);
        // die('#8');
        if ($autogen)  {
            $data['poster'] .= '&autogen=1';
            $data['preview'] .= '&autogen=1';
            $data['motiv_accepted'] = '0';
        }
        // Update the database entry
        $res = $this->db->exec_SELECTquery('*', 'Login_auftrag_motive', 'auftrag_nummer='.(int)$this->hash);
        // User already exists, set the user to disabled and to the usergroup
        if ($this->db->sql_num_rows($res)) {
            unset($data['auftrag_nummer']);
            $this->db->exec_UPDATEquery('Login_auftrag_motive', "auftrag_nummer='".(int)$this->hash."'", $data);
        } else {
            $this->db->exec_INSERTquery('Login_auftrag_motive', $data);
        }
        // Return the updated data
        return (array)$data;
    }


    /**
     * Create the formular with the dynamic userdata to fill in
     *
     * @return	string		The content that is displayed on the website
     */
    protected function createDynamicForm() {
        $content = '';
        $additionalFields = array('onchange', 'onclick', 'style');
        $template = trim($this->cObj->getSubpart($this->template, '###FIELDS###'));
        // Render each field
        foreach ($this->fields as $field) {
            $label = trim($field['attributes']['code']);
            $type = trim($field['attributes']['type']);
            $includeMail = trim($field['attributes']['inludeMail']);
            if ($includeMail) $this->session['includeMail'][$label] = $this->data[$label];
            // Get marks for each line
            $marks = array(
                'class' => (!$this->firstCall && $this->errorFields[$label]) ? ' class="required"' : '',
                'label' => $this->p123_getLL('field'.$label) ? '###LL_field'.$label.'###' : $label,
                'prefix' => $this->prefixId,
                'field' => $label,
                'value' => $this->data[$label],
                'additionalFields' => '',
            );

            $this->errorMarkers[$label] = (!$this->firstCall && $this->errorFields[$label]) ? 'required' : '';
            // Clear the subparts
            $subparts = array(
                '###CHECKBOX###' => '',
                '###INPUT###' => '',
                '###SELECT###' => '',
                '###FILE###' => '',
                '###HIDDEN###' => '',
            );
            // File upload
            if (isset($this->uploadFields[$label])) {
                $subparts['###HIDDEN###'] = trim($this->cObj->getSubpart($template, '###HIDDEN###'));
                $subparts['###HIDDEN###'] = $this->substituteSubpartArray($subparts['###HIDDEN###'], array(
                    '###UPLOAD###' => empty($this->data[$label]) ? trim($this->cObj->getSubpart($subparts['###HIDDEN###'], '###UPLOAD###')) : '',
                    '###REMOVE###' => empty($this->data[$label]) ? '' : trim($this->cObj->getSubpart($subparts['###HIDDEN###'], '###REMOVE###')),
                ));
                // Normal input fields
            } else {
                switch(strtolower($type)) {
                    // Select
                    case 'select':
                        $subparts['###SELECT###'] = trim($this->cObj->getSubpart($template, '###SELECT###'));
                        $tmpTemplate = trim($this->cObj->getSubpart($subparts['###SELECT###'], '###OPTION###'));
                        $options = \TYPO3\CMS\Core\Utility\GeneralUtility::trimExplode('|', $field['attributes']['option'], TRUE);
                        $tmpContent = '';

                        for ($i = 0; $i < count($options); $i++) {
                            $tmpData = $marks;
                            $tmpData['value'] = $this->p123_getLL('field'.$options[$i]) ? '###LL_field'.$options[$i].'###' : $options[$i];
                            $tmpData['bvalue'] = $options[$i];
                            $tmpData['selected'] = ($tmpData['bvalue'] == $this->data[$label]) ? ' selected="selected"' : '';
                            $tmpContent .= trim($this->cObj->substituteMarkerArray($tmpTemplate, $tmpData, '###DATA_|###'));
                        }
                        $subparts['###SELECT###'] = trim($this->cObj->substituteSubpart($subparts['###SELECT###'], '###OPTION###', $tmpContent));
                        break;
                    case 'checkbox':
                        $subparts['###CHECKBOX###'] = trim($this->cObj->getSubpart($template, '###CHECKBOX###'));
                        if ((isset($this->piVars['select']) && $this->data[$label]) || !empty($this->piVars[$label])) {
                            $marks['additionalFields'] .= ' checked="" ';
                        }
                        if ($includeMail) $this->session['includeMail'][$label] = $this->piVars[$label] ? 1 : 0;
                        break;

                    // Input type=text
                    default:
                        $subparts['###INPUT###'] = trim($this->cObj->getSubpart($template, '###INPUT###'));
                        $marks['maxlength'] = $field['attributes']['size'];
                        break;
                }

                foreach ($field['attributes'] as $a_keys => $a_val) {
                    if (in_array(strToLower($a_keys), $additionalFields)) {
                        $marks['additionalFields'] .= ' ' . $a_keys . '="' .  $a_val . '"';
                    }
                }

            }


            // Render the formular line
            $content .= trim($this->cObj->substituteMarkerArray(trim($this->substituteSubpartArray($template, $subparts)), $marks, '###DATA_|###'));

        }
        $this->pi_SESsave();
        return (string)$content;
    }


    /**
     * Substitues multiple subparts at once
     *
     * @param	string		The content stream, typically HTML template content.
     * @param	array		The array of key/value pairs being subpart/content values used in the substitution. For each element in this array the function will substitute a subpart in the content stream with the content.
     * @return	string		The processed HTML content string.
     */
    public function substituteSubpartArray($content, array $subpartsContent) {
        foreach ($subpartsContent as $subpartMarker => $subpartContent) {
            $content = $this->cObj->substituteSubpart(
                $content,
                $subpartMarker,
                $subpartContent
            );
        }

        return $content;
    }

    /**
     * Returns the localized label of the LOCAL_LANG key, $key
     *
     * @param	string		The key from the LOCAL_LANG array for which to return the value.
     * @return	string		The value from LOCAL_LANG.
     */
    protected function p123_getLL($key)	{
        if (isset($this->LOCAL_LANG[$this->LLkey][$key]))	{
            return (string)$this->LOCAL_LANG[$this->LLkey][$key];
        } elseif ($this->altLLkey && isset($this->LOCAL_LANG[$this->altLLkey][$key]))	{
            return (string)$this->LOCAL_LANG_charset[$this->altLLkey][$key];
        } elseif (isset($this->LOCAL_LANG['default'][$key]))	{
            return (string)$this->LOCAL_LANG['default'][$key];
        }
        return '';
    }

    /**
     * Set new localized label $newVal of the LOCAL_LANG key, $key
     *
     * @param	string		The key from the LOCAL_LANG array for which to return the value.
     * @param	string		Alternative string to return IF no value is found set for the key, neither for the local language nor the default.
     * @return	void
     */
    protected function p123_setLL($key, $newVal)	{
        if (isset($this->LOCAL_LANG[$this->LLkey][$key]))	{
            $this->LOCAL_LANG[$this->LLkey][$key] = (string)$newVal;
        } elseif ($this->altLLkey && isset($this->LOCAL_LANG[$this->altLLkey][$key]))	{
            $this->LOCAL_LANG[$this->altLLkey][$key] = (string)$newVal;
        } elseif (isset($this->LOCAL_LANG['default'][$key]))	{
            $this->LOCAL_LANG['default'][$key] = (string)$newVal;
        }
    }

    public function redirect($url, $httpStatus = 'HTTP/1.1 200 OK') {
        header($httpStatus);
        header('Location: ' . \TYPO3\CMS\Core\Utility\GeneralUtility::locationHeaderUrl($url));
        exit;
    }

}





if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi5/class.tx_cawlogin_pi5.php'])	{
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi5/class.tx_cawlogin_pi5.php']);
}
