<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2020 Dennis Robota-Özet <info@doemedia.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('cawlogin').'plugins/pi/class.tx_cawlogin_pi.php');


/**
 * Plugin 'CAW Customer Basket' for the 'cawlogin' extension.
 *
 * @author	Dennis Robota-Özet <info@doemedia.de>
 * @package	TYPO3
 * @subpackage	tx_cawlogin
 */
class tx_cawlogin_pi9 extends tx_cawlogin_pi {
    public $prefixId = 'tx_cawlogin_pi9';        // Same as class name
    public $scriptRelPath = 'plugins/pi9/class.tx_cawlogin_pi9.php';    // Path to this script relative to the extension dir.
    public $extKey = 'cawlogin';    // The extension key.

    /**
     * The main method of the PlugIn
     *
     * @param	string		$strContent: The PlugIn content
     * @param	array		$arrConf: The PlugIn configuration
     * @return	string		The content that is displayed on the website
     */
    public function main($strContent, array $arrConf) {
        $this->conf = $arrConf;
        $this->pi_setPiVarDefaults();
        parent::init();

        // Get the template
        $strFileResource = $this->cObj->stdWrap($this->conf['templateFile'], $this->conf['templateFile.']);
        $strTemplate = $this->cObj->fileResource($strFileResource);
        $strTemplate = $this->cObj->getSubpart($strTemplate, '###'.$this->prefixId.'###');

        // Get order
        $arrOrder = $this->pi_DBgetOrder();
        $arrData = array('sumBasket' => '');


        if($arrOrder['auftrag_preis'] && $arrOrder['auftrag_selection']) {

            $arrData['sumBasket'] = $this->pi_DBgetPrice(0, 0, TRUE, TRUE);
            $strContent = $this->pi_TPLsubstituteDataMarker($strTemplate, $arrData);
        }

        return $strContent;
    }
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi9/class.tx_cawlogin_pi9.php'])	{
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cawlogin/plugins/pi9/class.tx_cawlogin_pi9.php']);
}